/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);

// src/BaseLayout.jsx
var BaseLayout_exports = {};
__export(BaseLayout_exports, {
  default: () => BaseLayout_default
});
module.exports = __toCommonJS(BaseLayout_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:prop-types
var prop_types_exports = {};
__export(prop_types_exports, {
  default: () => prop_types_default
});
var defaultImport2 = __toESM(require("prop-types"));
__reExport(prop_types_exports, require("prop-types"));
var prop_types_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport3 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/BaseLayout.jsx
var BaseLayout = class extends react_exports.Component {
  render() {
    return null;
  }
};
__publicField(BaseLayout, "propTypes", {
  /**
   * dashboard mode
   */
  mode: prop_types_default.string,
  /**
   * whether gridlines should be displayed in edit mode
   */
  showGrid: prop_types_default.bool,
  /**
   * layout formatting options
   */
  options: prop_types_default.object,
  /**
   * layout structure
   */
  layoutStructure: prop_types_default.arrayOf(prop_types_default.any),
  /**
   * container width in pixel
   */
  containerWidth: prop_types_default.number,
  /**
   * container height in pixel
   */
  containerHeight: prop_types_default.number,
  /**
   * list of selected items
   */
  selectedItems: prop_types_default.arrayOf(
    prop_types_default.shape({ id: prop_types_default.string, type: prop_types_default.oneOf(["block", "line", "input"]) })
  ),
  /**
   * layout item render prop
   */
  renderLayoutItem: prop_types_default.func,
  /**
   * callback when items are selected
   */
  onLayoutItemsSelect: prop_types_default.func,
  /**
   * callback to trigger event
   */
  onEventTrigger: prop_types_default.func,
  /**
   * callback when layout structure changed
   */
  onLayoutStructureChange: prop_types_default.func,
  /**
   * layoutApi ref
   */
  layoutApiRef: prop_types_default.func
});
__publicField(BaseLayout, "defaultProps", {
  mode: "view",
  options: {},
  showGrid: true,
  layoutStructure: [],
  selectedItems: [],
  renderLayoutItem: dashboard_utils_exports.noop,
  onEventTrigger: dashboard_utils_exports.noop,
  onLayoutStructureChange: dashboard_utils_exports.noop,
  onLayoutItemsSelect: dashboard_utils_exports.noop,
  layoutApiRef: dashboard_utils_exports.noop
});
var BaseLayout_default = BaseLayout;
//# sourceMappingURL=BaseLayout.js.map
