/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/BaseLayoutApi.ts
var BaseLayoutApi_exports = {};
__export(BaseLayoutApi_exports, {
  default: () => BaseLayoutApi_default
});
module.exports = __toCommonJS(BaseLayoutApi_exports);
var BaseLayoutApi = class {
  constructor() {
    this.emitTelemetry = (payload) => {
      if (!this.telemetry) {
        return false;
      }
      this.telemetry.emit(__spreadValues({
        source: "layoutApi"
      }, payload));
      return true;
    };
  }
  /**
   * add new layout item synchronously
   */
  addLayoutItemSync(...args) {
    return this.addLayoutItem(...args);
  }
  /**
   * add one or more new layout items
   */
  addLayoutItems(items, metadata) {
    return this.addLayoutItemSync(
      items,
      metadata
    );
  }
  /**
   * copies item w/h and position with an offset synchronously
   */
  cloneLayoutItemsSync({ from, to }) {
    return this.cloneLayoutItems({ from, to });
  }
  /**
   * remove an item from layout synchronously
   */
  removeLayoutItemsSync(itemIds) {
    return this.removeLayoutItems(itemIds);
  }
};
var BaseLayoutApi_default = BaseLayoutApi;
//# sourceMappingURL=BaseLayoutApi.js.map
