/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/InputLayout.tsx
var InputLayout_exports = {};
__export(InputLayout_exports, {
  default: () => InputLayout_default
});
module.exports = __toCommonJS(InputLayout_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:styled-components
var styled_components_exports = {};
__export(styled_components_exports, {
  default: () => styled_components_default
});
var defaultImport2 = __toESM(require("styled-components"));
__reExport(styled_components_exports, require("styled-components"));
var styled_components_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@dnd-kit/core
var core_exports = {};
__export(core_exports, {
  default: () => core_default
});
var defaultImport3 = __toESM(require("@dnd-kit/core"));
__reExport(core_exports, require("@dnd-kit/core"));
var core_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@dnd-kit/sortable
var sortable_exports = {};
__export(sortable_exports, {
  default: () => sortable_default
});
var defaultImport4 = __toESM(require("@dnd-kit/sortable"));
__reExport(sortable_exports, require("@dnd-kit/sortable"));
var sortable_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@dnd-kit/utilities
var utilities_exports = {};
__export(utilities_exports, {
  default: () => utilities_default
});
var defaultImport5 = __toESM(require("@dnd-kit/utilities"));
__reExport(utilities_exports, require("@dnd-kit/utilities"));
var utilities_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport6 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/dashboard-context
var dashboard_context_exports = {};
__export(dashboard_context_exports, {
  default: () => dashboard_context_default
});
var defaultImport7 = __toESM(require("@splunk/dashboard-context"));
__reExport(dashboard_context_exports, require("@splunk/dashboard-context"));
var dashboard_context_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport8 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// esm-externals:@splunk/dashboard-ui
var dashboard_ui_exports = {};
__export(dashboard_ui_exports, {
  default: () => dashboard_ui_default
});
var defaultImport9 = __toESM(require("@splunk/dashboard-ui"));
__reExport(dashboard_ui_exports, require("@splunk/dashboard-ui"));
var dashboard_ui_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// src/InputLayoutViewer.tsx
var InputContainer = styled_components_default.div`
    ${themes_exports.mixins.reset("block")};
    padding: 8px 0px;
    background: ${(prop) => prop.backgroundColor || dashboard_ui_exports.customThemeVariables.dashboardBackgroundColor};
    display: flex;
    flex-wrap: wrap;

    &:empty {
        padding: 0;
    }
`;
var defaultInputRender = () => null;
var defaultStructure = [];
var InputSubmitButton = ({
  disabled,
  onClick
}) => {
  const { setNodeRef, transform } = (0, sortable_exports.useSortable)({
    id: dashboard_context_exports.GlobalInputSubmitDraggableId,
    disabled: true
  });
  const containerStyle = (0, react_exports.useMemo)(
    () => ({ transform: utilities_exports.CSS.Translate.toString(transform) }),
    [transform]
  );
  return /* @__PURE__ */ react_default.createElement(
    dashboard_ui_exports.SubmitButton,
    {
      key: "submit_button",
      "data-test": "input-item-submit-button",
      ref: setNodeRef,
      containerStyle,
      disabled,
      onClick
    }
  );
};
var InputLayout = (0, react_exports.forwardRef)(
  ({
    submitButton = false,
    submitButtonDisabled = false,
    inputStructure = defaultStructure,
    renderInput = defaultInputRender,
    onSubmitButtonClick = dashboard_utils_exports.noop
  }, ref) => {
    const { setNodeRef } = (0, core_exports.useDroppable)({ id: dashboard_context_exports.GlobalInputDropzoneId });
    const composedRef = (0, react_exports.useCallback)(
      (element) => {
        if (ref) {
          if (typeof ref === "function") {
            ref(element);
          } else {
            ref.current = element;
          }
        }
        setNodeRef(element);
      },
      [ref, setNodeRef]
    );
    if (inputStructure.length === 0) {
      return null;
    }
    const renderSubmitButton = !!(inputStructure.length && submitButton);
    return /* @__PURE__ */ react_default.createElement(
      InputContainer,
      {
        ref: composedRef,
        "data-test": "input-layout-container"
      },
      inputStructure.map(
        (inputId, index) => renderInput({ inputId, index })
      ),
      renderSubmitButton && /* @__PURE__ */ react_default.createElement(
        InputSubmitButton,
        {
          disabled: submitButtonDisabled,
          onClick: onSubmitButtonClick
        }
      )
    );
  }
);
var InputLayoutViewer_default = InputLayout;

// src/InputLayout.tsx
var InputLayout_default = InputLayoutViewer_default;
//# sourceMappingURL=InputLayout.js.map
