/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/absoluteLayoutOptionsSchema.ts
var absoluteLayoutOptionsSchema_exports = {};
__export(absoluteLayoutOptionsSchema_exports, {
  default: () => absoluteLayoutOptionsSchema_default
});
module.exports = __toCommonJS(absoluteLayoutOptionsSchema_exports);

// esm-externals:@splunk/dashboard-definition
var dashboard_definition_exports = {};
__export(dashboard_definition_exports, {
  default: () => dashboard_definition_default
});
var defaultImport = __toESM(require("@splunk/dashboard-definition"));
__reExport(dashboard_definition_exports, require("@splunk/dashboard-definition"));
var dashboard_definition_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/dashboard-ui
var dashboard_ui_exports = {};
__export(dashboard_ui_exports, {
  default: () => dashboard_ui_default
});
var defaultImport2 = __toESM(require("@splunk/dashboard-ui"));
__reExport(dashboard_ui_exports, require("@splunk/dashboard-ui"));
var dashboard_ui_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport3 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/absoluteLayoutOptionsSchema.ts
var absoluteLayoutOptionsSchema_default = {
  backgroundColor: {
    anyOf: [
      {
        pattern: dashboard_definition_exports.COLOR_PATTERN_WITH_RGBA_AND_TOKEN,
        type: "string",
        description: `Specify the color of the layout background color using using a hex code, rgb/rgba value, an HTML color name, or a token.

The default for light mode is "#F2F4f5". The default for dark mode is "#3C444D". The default for SCP mode is "#15161B"`
      },
      {
        type: "string",
        enum: dashboard_ui_exports.namedColors,
        description: `Specify the color of the layout background color using a valid web color such as 'blue'`
      }
    ]
  },
  display: {
    type: "string",
    default: "auto",
    enum: ["actual-size", "fit-to-width", "auto", "auto-scale"],
    description: `Specify the display behavior. Valid options are:


actual-size: The dashboard will not change size when the browser is resized.


fit-to-width: The dashboard will change in size as the browser is resized, always filling the available width of the browser.


auto: The dashboard will change in size as the browser is resized, to a maximum zoom of 100%.`
  },
  backgroundImage: {
    type: "object",
    properties: {
      w: {
        type: "number",
        description: `Specify the image's h (height) and w (width) in pixels. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting.`
      },
      h: {
        type: "number",
        description: `Specify the image's h (height) and w (width) in pixels. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting.`
      },
      x: {
        type: "number",
        description: "Specify, in pixels, the position of the background image on the x-axis and y-axis. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting."
      },
      y: {
        type: "number",
        description: "Specify, in pixels, the position of the background image on the x-axis and y-axis. These options should not be specified if you set the sizeType option. If they are, they will overrule that setting."
      },
      src: {
        type: "string",
        description: "The url of background image."
      },
      opacity: {
        type: "number",
        minimum: 0,
        maximum: 1,
        description: "The opacity of the image."
      },
      sizeType: {
        type: "string",
        enum: ["auto", "contain", "cover"],
        default: "contain",
        description: `Specify one of the following:


auto: Scales the image while maintaining the image proportion.


contain: Increases the size of the of the image as much as possible without cropping or stretching it.


cover: Increases the size of the image without stretching it. The image may be cropped vertically and horizontally so that no empty space is shown.`
      }
    },
    description: `A background image must be one of the following types: jpg, jpeg, png, svg, or gif

Specify the location of a background image using the option src. For example: "src": "https://www.myImageLocation.com/galleryX/image1.png`,
    additionalProperties: false
  },
  width: {
    type: "number",
    default: dashboard_utils_exports.DEFAULT_CANVAS_WIDTH,
    description: "Canvas width in pixels."
  },
  height: {
    type: "number",
    default: dashboard_utils_exports.DEFAULT_CANVAS_HEIGHT,
    description: "Canvas height in pixels."
  }
};
//# sourceMappingURL=absoluteLayoutOptionsSchema.js.map
