/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/gridLayoutOptionsSchema.ts
var gridLayoutOptionsSchema_exports = {};
__export(gridLayoutOptionsSchema_exports, {
  default: () => gridLayoutOptionsSchema_default
});
module.exports = __toCommonJS(gridLayoutOptionsSchema_exports);

// esm-externals:@splunk/dashboard-ui
var dashboard_ui_exports = {};
__export(dashboard_ui_exports, {
  default: () => dashboard_ui_default
});
var defaultImport = __toESM(require("@splunk/dashboard-ui"));
__reExport(dashboard_ui_exports, require("@splunk/dashboard-ui"));
var dashboard_ui_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/dashboard-definition
var dashboard_definition_exports = {};
__export(dashboard_definition_exports, {
  default: () => dashboard_definition_default
});
var defaultImport2 = __toESM(require("@splunk/dashboard-definition"));
__reExport(dashboard_definition_exports, require("@splunk/dashboard-definition"));
var dashboard_definition_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// src/gridLayoutOptionsSchema.ts
var gridLayoutOptionsSchema_default = {
  gutterSize: {
    type: "number",
    default: 8,
    minimum: 8,
    maximum: 16,
    description: "A number that represents the size of the gutter between visualizations in pixels. The minimum value is 8 and maximum value is 16."
  },
  backgroundColor: {
    type: "string",
    description: `Specify the color of the layout background using a hex code, rgb/rgba value, an HTML color name, or a token`,
    anyOf: [
      { enum: dashboard_ui_exports.namedColors },
      { pattern: dashboard_definition_exports.COLOR_PATTERN_WITH_RGBA_AND_TOKEN }
    ]
  }
};
//# sourceMappingURL=gridLayoutOptionsSchema.js.map
