/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
import {
  styled_components_default,
  styled_components_exports
} from "./chunk-AZNCU5D5.js";
import {
  dashboard_context_exports,
  themes_exports
} from "./chunk-2OPMAP46.js";
import {
  dashboard_ui_exports
} from "./chunk-V6LCPHRJ.js";
import {
  react_default,
  react_exports
} from "./chunk-D2UIVRV7.js";
import {
  dashboard_utils_exports
} from "./chunk-QCW3O7QD.js";
import {
  __export,
  __reExport
} from "./chunk-W3Q7A2F6.js";

// esm-externals:@dnd-kit/core
var core_exports = {};
__export(core_exports, {
  default: () => core_default
});
__reExport(core_exports, core_star);
import * as defaultImport from "@dnd-kit/core";
import * as core_star from "@dnd-kit/core";
var core_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@dnd-kit/sortable
var sortable_exports = {};
__export(sortable_exports, {
  default: () => sortable_default
});
__reExport(sortable_exports, sortable_star);
import * as defaultImport2 from "@dnd-kit/sortable";
import * as sortable_star from "@dnd-kit/sortable";
var sortable_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@dnd-kit/utilities
var utilities_exports = {};
__export(utilities_exports, {
  default: () => utilities_default
});
__reExport(utilities_exports, utilities_star);
import * as defaultImport3 from "@dnd-kit/utilities";
import * as utilities_star from "@dnd-kit/utilities";
var utilities_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/InputLayoutViewer.tsx
var InputContainer = styled_components_default.div`
    ${themes_exports.mixins.reset("block")};
    padding: 8px 0px;
    background: ${(prop) => prop.backgroundColor || dashboard_ui_exports.customThemeVariables.dashboardBackgroundColor};
    display: flex;
    flex-wrap: wrap;

    &:empty {
        padding: 0;
    }
`;
var defaultInputRender = () => null;
var defaultStructure = [];
var InputSubmitButton = ({
  disabled,
  onClick
}) => {
  const { setNodeRef, transform } = (0, sortable_exports.useSortable)({
    id: dashboard_context_exports.GlobalInputSubmitDraggableId,
    disabled: true
  });
  const containerStyle = (0, react_exports.useMemo)(
    () => ({ transform: utilities_exports.CSS.Translate.toString(transform) }),
    [transform]
  );
  return /* @__PURE__ */ react_default.createElement(
    dashboard_ui_exports.SubmitButton,
    {
      key: "submit_button",
      "data-test": "input-item-submit-button",
      ref: setNodeRef,
      containerStyle,
      disabled,
      onClick
    }
  );
};
var InputLayout = (0, react_exports.forwardRef)(
  ({
    submitButton = false,
    submitButtonDisabled = false,
    inputStructure = defaultStructure,
    renderInput = defaultInputRender,
    onSubmitButtonClick = dashboard_utils_exports.noop
  }, ref) => {
    const { setNodeRef } = (0, core_exports.useDroppable)({ id: dashboard_context_exports.GlobalInputDropzoneId });
    const composedRef = (0, react_exports.useCallback)(
      (element) => {
        if (ref) {
          if (typeof ref === "function") {
            ref(element);
          } else {
            ref.current = element;
          }
        }
        setNodeRef(element);
      },
      [ref, setNodeRef]
    );
    if (inputStructure.length === 0) {
      return null;
    }
    const renderSubmitButton = !!(inputStructure.length && submitButton);
    return /* @__PURE__ */ react_default.createElement(
      InputContainer,
      {
        ref: composedRef,
        "data-test": "input-layout-container"
      },
      inputStructure.map(
        (inputId, index) => renderInput({ inputId, index })
      ),
      renderSubmitButton && /* @__PURE__ */ react_default.createElement(
        InputSubmitButton,
        {
          disabled: submitButtonDisabled,
          onClick: onSubmitButtonClick
        }
      )
    );
  }
);
var InputLayoutViewer_default = InputLayout;

export {
  InputLayoutViewer_default
};
//# sourceMappingURL=chunk-7QRN7NRK.js.map
