/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
import {
  __spreadValues
} from "./chunk-W3Q7A2F6.js";

// src/BaseLayoutApi.ts
var BaseLayoutApi = class {
  constructor() {
    this.emitTelemetry = (payload) => {
      if (!this.telemetry) {
        return false;
      }
      this.telemetry.emit(__spreadValues({
        source: "layoutApi"
      }, payload));
      return true;
    };
  }
  /**
   * add new layout item synchronously
   */
  addLayoutItemSync(...args) {
    return this.addLayoutItem(...args);
  }
  /**
   * add one or more new layout items
   */
  addLayoutItems(items, metadata) {
    return this.addLayoutItemSync(
      items,
      metadata
    );
  }
  /**
   * copies item w/h and position with an offset synchronously
   */
  cloneLayoutItemsSync({ from, to }) {
    return this.cloneLayoutItems({ from, to });
  }
  /**
   * remove an item from layout synchronously
   */
  removeLayoutItemsSync(itemIds) {
    return this.removeLayoutItems(itemIds);
  }
};
var BaseLayoutApi_default = BaseLayoutApi;

export {
  BaseLayoutApi_default
};
//# sourceMappingURL=chunk-D6XDCMUA.js.map
