/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
import {
  prop_types_default,
  prop_types_exports
} from "./chunk-RVNUZD6H.js";
import {
  react_exports
} from "./chunk-D2UIVRV7.js";
import {
  dashboard_utils_exports
} from "./chunk-QCW3O7QD.js";
import {
  __publicField
} from "./chunk-W3Q7A2F6.js";

// src/BaseLayout.jsx
var BaseLayout = class extends react_exports.Component {
  render() {
    return null;
  }
};
__publicField(BaseLayout, "propTypes", {
  /**
   * dashboard mode
   */
  mode: prop_types_default.string,
  /**
   * whether gridlines should be displayed in edit mode
   */
  showGrid: prop_types_default.bool,
  /**
   * layout formatting options
   */
  options: prop_types_default.object,
  /**
   * layout structure
   */
  layoutStructure: prop_types_default.arrayOf(prop_types_default.any),
  /**
   * container width in pixel
   */
  containerWidth: prop_types_default.number,
  /**
   * container height in pixel
   */
  containerHeight: prop_types_default.number,
  /**
   * list of selected items
   */
  selectedItems: prop_types_default.arrayOf(
    prop_types_default.shape({ id: prop_types_default.string, type: prop_types_default.oneOf(["block", "line", "input"]) })
  ),
  /**
   * layout item render prop
   */
  renderLayoutItem: prop_types_default.func,
  /**
   * callback when items are selected
   */
  onLayoutItemsSelect: prop_types_default.func,
  /**
   * callback to trigger event
   */
  onEventTrigger: prop_types_default.func,
  /**
   * callback when layout structure changed
   */
  onLayoutStructureChange: prop_types_default.func,
  /**
   * layoutApi ref
   */
  layoutApiRef: prop_types_default.func
});
__publicField(BaseLayout, "defaultProps", {
  mode: "view",
  options: {},
  showGrid: true,
  layoutStructure: [],
  selectedItems: [],
  renderLayoutItem: dashboard_utils_exports.noop,
  onEventTrigger: dashboard_utils_exports.noop,
  onLayoutStructureChange: dashboard_utils_exports.noop,
  onLayoutItemsSelect: dashboard_utils_exports.noop,
  layoutApiRef: dashboard_utils_exports.noop
});
var BaseLayout_default = BaseLayout;

export {
  BaseLayout_default
};
//# sourceMappingURL=chunk-IJD6LVGH.js.map
