/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
import {
  dashboard_definition_exports
} from "./chunk-UUGRNOSW.js";
import {
  dashboard_ui_exports
} from "./chunk-V6LCPHRJ.js";

// src/gridLayoutOptionsSchema.ts
var gridLayoutOptionsSchema_default = {
  gutterSize: {
    type: "number",
    default: 8,
    minimum: 8,
    maximum: 16,
    description: "A number that represents the size of the gutter between visualizations in pixels. The minimum value is 8 and maximum value is 16."
  },
  backgroundColor: {
    type: "string",
    description: `Specify the color of the layout background using a hex code, rgb/rgba value, an HTML color name, or a token`,
    anyOf: [
      { enum: dashboard_ui_exports.namedColors },
      { pattern: dashboard_definition_exports.COLOR_PATTERN_WITH_RGBA_AND_TOKEN }
    ]
  }
};

export {
  gridLayoutOptionsSchema_default
};
//# sourceMappingURL=chunk-XY7D6A2V.js.map
