export default BaseLayout;
declare class BaseLayout extends Component<any, any, any> {
    static propTypes: {
        /**
         * dashboard mode
         */
        mode: T.Requireable<string>;
        /**
         * whether gridlines should be displayed in edit mode
         */
        showGrid: T.Requireable<boolean>;
        /**
         * layout formatting options
         */
        options: T.Requireable<object>;
        /**
         * layout structure
         */
        layoutStructure: T.Requireable<any[]>;
        /**
         * container width in pixel
         */
        containerWidth: T.Requireable<number>;
        /**
         * container height in pixel
         */
        containerHeight: T.Requireable<number>;
        /**
         * list of selected items
         */
        selectedItems: T.Requireable<(T.InferProps<{
            id: T.Requireable<string>;
            type: T.Requireable<string>;
        }> | null | undefined)[]>;
        /**
         * layout item render prop
         */
        renderLayoutItem: T.Requireable<(...args: any[]) => any>;
        /**
         * callback when items are selected
         */
        onLayoutItemsSelect: T.Requireable<(...args: any[]) => any>;
        /**
         * callback to trigger event
         */
        onEventTrigger: T.Requireable<(...args: any[]) => any>;
        /**
         * callback when layout structure changed
         */
        onLayoutStructureChange: T.Requireable<(...args: any[]) => any>;
        /**
         * layoutApi ref
         */
        layoutApiRef: T.Requireable<(...args: any[]) => any>;
    };
    static defaultProps: {
        mode: string;
        options: {};
        showGrid: boolean;
        layoutStructure: never[];
        selectedItems: never[];
        renderLayoutItem: (...args: any[]) => any;
        onEventTrigger: (...args: any[]) => any;
        onLayoutStructureChange: (...args: any[]) => any;
        onLayoutItemsSelect: (...args: any[]) => any;
        layoutApiRef: (...args: any[]) => any;
    };
    constructor(props: any);
    constructor(props: any, context: any);
    render(): null;
}
import { Component } from 'react';
import T from 'prop-types';
//# sourceMappingURL=BaseLayout.d.ts.map