import type { AbsoluteBlockItem, GridLayoutStructure } from '@splunk/dashboard-types';
import type { SplitGridEntry } from './gridOrderUtils';
type ContainingRowColumn = SplitGridEntry | undefined;
/**
 * Get the smallest row or column (not necessarily full-width or full-height) which
 * contains a specified item, but is not solely the specified item. If no such container
 * is found then undefined is returned
 * @param {GridLayoutStructure} param0.structure The layout structure to be searched
 * @param {AbsoluteBlockItem} param0.itemToContain The block item to be contained by the resulting row/column
 * @returns The smallest row or column containing the target item and at least one other block item, or undefined
 */
export declare const getContainingRowColumn: ({ structure, itemToContain, }: {
    structure: GridLayoutStructure;
    itemToContain: AbsoluteBlockItem;
}) => ContainingRowColumn;
export {};
//# sourceMappingURL=getContainingRowColumn.d.ts.map