import type { AbsoluteBlockItem, Coordinate } from '@splunk/dashboard-types';
import type { Intersections } from './edgeUtils';
export type SplitGridEntry = {
    nodes: Intersections;
    layout: AbsoluteBlockItem[];
    gridWidth: number;
    gridHeight: number;
    origin: Coordinate;
    content: {
        width: number;
        height: number;
        items: AbsoluteBlockItem[];
    };
};
export type SplitGrid = SplitGridEntry[];
type ItemXPos = number;
type ItemYPos = number;
export type ItemCoordinateMap = Record<ItemYPos, Record<ItemXPos, AbsoluteBlockItem>>;
export declare const trackItemsByCoordinate: (layout: AbsoluteBlockItem[]) => ItemCoordinateMap;
export declare const getItemsInCoordinateRange: ({ itemCoordinateMap, range, }: {
    itemCoordinateMap: ItemCoordinateMap;
    range?: {
        from?: Partial<Coordinate>;
        to?: Partial<Coordinate>;
    };
}) => AbsoluteBlockItem[];
export declare const splitGridByRows: ({ nodes, layout, gridWidth, gridHeight, originViz, alwaysIncludeLastRow, }: {
    nodes: Intersections;
    layout: AbsoluteBlockItem[];
    gridWidth: number;
    gridHeight: number;
    originViz: AbsoluteBlockItem;
    alwaysIncludeLastRow?: boolean;
}) => SplitGrid;
export declare const splitGridByColumns: ({ nodes, layout, gridWidth, gridHeight, originViz, }: {
    nodes: Intersections;
    layout: AbsoluteBlockItem[];
    gridWidth: number;
    gridHeight: number;
    originViz: AbsoluteBlockItem;
}) => SplitGrid;
export declare const getGridLayoutOrder: ({ layout, canvasWidth, canvasHeight, }: {
    layout: AbsoluteBlockItem[];
    canvasWidth: number;
    canvasHeight: number;
}) => AbsoluteBlockItem[];
export {};
//# sourceMappingURL=gridOrderUtils.d.ts.map