import React from 'react';
import type { ConnectedLineProps } from './types';
declare const ConnectedLine: {
    ({ from, to, onLineSelect, options, dataSources, context, }: ConnectedLineProps): React.JSX.Element;
    config: {
        optionsSchema: {
            toArrow: {
                type: string;
                default: boolean;
                description: string;
            };
            fromArrow: {
                type: string;
                default: boolean;
                description: string;
            };
            strokeColor: {
                anyOf: ({
                    type: string;
                    pattern: RegExp;
                    description: string;
                } | {
                    type: string;
                    pattern: string;
                    description?: undefined;
                })[];
            };
            strokeDataSeries: {
                type: string;
                pattern: string;
                description: string;
                default: string;
            };
            strokeDataPoint: {
                type: string;
                pattern: string;
                description: string;
                default: string;
            };
            strokeDasharray: {
                type: string;
                default: number;
                description: string;
            };
            strokeWidth: {
                type: string;
                default: number;
                description: string;
            };
            strokeOpacity: {
                type: string;
                default: number;
                description: string;
            };
        };
        editorConfig: import("./ConnectedLineEditorConfig").EditorSection[];
        dataContract: {
            requiredDataSources: string[];
            initialRequestParams: {};
        };
        key: string;
        name: any;
        category: string | undefined;
        icon: ({ children, variant, ...otherprops }: import("@splunk/react-icons/Line").IconBaseProps) => JSX.Element | null;
        events: {};
        supports: string[];
        requiredProps: never[];
    };
};
export default ConnectedLine;
//# sourceMappingURL=ConnectedLine.d.ts.map