import type { DataSources } from '@splunk/dashboard-ui';
import type { Coordinate } from '@splunk/dashboard-types';
export interface ConnectedLineOptions {
    strokeColor?: string;
    strokeDataSeries?: string;
    strokeDataPoint?: string;
    strokeOpacity?: number;
    strokeWidth?: number;
    strokeDasharray?: number;
    fromArrow?: boolean;
    toArrow?: boolean;
}
export interface ConnectedLineProps {
    /**
     * Starting Coordinates of the Line
     */
    from?: Coordinate;
    /**
     * Ending Coordinates of the Line
     */
    to?: Coordinate;
    /**
     * Visualization formatting options
     */
    options?: ConnectedLineOptions;
    /**
     * on line select callback
     */
    onLineSelect?: React.MouseEventHandler;
    dataSources?: DataSources;
    context?: Record<string, unknown>;
}
//# sourceMappingURL=index.d.ts.map