import type { Coordinate } from '@splunk/dashboard-types';
/**
 * Computes the Arrow's triangle dimensions
 * @param {Number} w line width
 * @param {Number} h line height
 * @param {Number} l line length
 * @param {Number} L arrow length
 */
export declare const computeArrowTriangle: (w: number, h: number, l: number, L: number) => {
    arrowW: number;
    arrowH: number;
    arrowL: number;
};
/**
 * Computes the To Arrow Angle to place at the From position of the line that is drawn
 * @param {Object} from x and y coordinate
 * @param {Object} to x and y coordinate
 */
export declare const computeFromArrowAngle: (from: Coordinate, to: Coordinate) => number;
/**
 * Computes the To Arrow Angle to place at the To position of the line that is drawn
 * @param {Object} from x and y coordinate
 * @param {Object} to x and y coordinate
 */
export declare const computeToArrowAngle: (from: Coordinate, to: Coordinate) => number;
/**
 * Computes the modified From coordinates depending on whether an arrow is present or not
 * @param {Object} from x and y coordinate
 * @param {Object} to x and y coordinate
 * @param {Number} arrowW the width of the drawn arrow, adjusted to the angle
 * @param {Number} arrowH the height of the drawn arrow, adjusted to the angle
 * @param {Boolean} fromArrow whether the From Arrow is present or not
 */
export declare const getNewFrom: (from: Coordinate, to: Coordinate, arrowW: number, arrowH: number, fromArrow: boolean) => {
    newFrom: {
        x: number;
        y: number;
    };
};
/**
 * Computes the modified To coordinates depending on whether an arrow is present or not
 * @param {Object} from x and y coordinate
 * @param {Object} to x and y coordinate
 * @param {Number} arrowW the width of the drawn arrow, adjusted to the angle
 * @param {Number} arrowH the height of the drawn arrow, adjusted to the angle
 * @param {Boolean} toArrow whether the To Arrow is present or not
 */
export declare const getNewTo: (from: Coordinate, to: Coordinate, arrowW: number, arrowH: number, toArrow: boolean) => {
    newTo: {
        x: number;
        y: number;
    };
};
/**
 * Computes the Path's (Line drawn) triangle dimensions
 * @param {Object} from x and y coordinate
 * @param {Object} to x and y coordinate
 */
export declare const computePathTriangle: (from: Coordinate, to: Coordinate) => {
    w: number;
    h: number;
    l: number;
};
//# sourceMappingURL=lineUtils.d.ts.map