/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/visualizations/ConnectedLineEditorConfig.ts
var ConnectedLineEditorConfig_exports = {};
__export(ConnectedLineEditorConfig_exports, {
  default: () => ConnectedLineEditorConfig_default,
  presets: () => presets
});
module.exports = __toCommonJS(ConnectedLineEditorConfig_exports);

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport2 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/visualizations/common/utils/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport3 = __toESM(require("@splunk/visualizations/common/utils/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations/common/utils/configUtils"));
var configUtils_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// src/visualizations/ConnectedLineEditorConfig.ts
var defaultContext = {
  defaultRangeValue: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ]
};
var basePresetContext = {
  strokeColorEditorConfig: void 0
};
var basePresetOptions = {
  strokeColor: void 0
};
var presets = [
  {
    label: (0, i18n_exports._)("Static"),
    name: "lineColor.static",
    value: {
      context: __spreadValues({}, basePresetContext),
      options: __spreadValues({}, basePresetOptions)
    }
  },
  {
    label: (0, i18n_exports._)("Dynamic"),
    name: "lineColor.dynamic",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        strokeColorEditorConfig: defaultContext.defaultRangeValue
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        strokeColor: "> strokeDataPoint | rangeValue(strokeColorEditorConfig)"
      })
    }
  }
];
var StaticColorEditor = {
  label: (0, i18n_exports._)("Color value"),
  option: "strokeColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options == null ? void 0 : options.strokeColor),
  editorProps: {
    labelPosition: "top",
    themeVariable: "@splunk/dashboard-layouts/ConnectedLine.strokeColor"
  }
};
var DynamicColorEditor = {
  label: (0, i18n_exports._)("Color range"),
  option: "strokeColor",
  context: "defaultContext",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options == null ? void 0 : options.strokeColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic line color"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        isDefault: true,
        // show it by default when open dynamic color flyout
        defaults: {
          strokeDataPoint: defaultContext.defaultRangeValue
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Color field"),
        value: "strokeDataPoint"
      }
    ],
    defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig
  }
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Selected data field"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Data field"),
          editor: "editor.columnSelector",
          option: "strokeDataSeries",
          context: "strokeDataContext",
          editorProps: {
            dataSourceKey: "primary",
            prepareValue: (definition) => {
              const {
                options: { strokeDataSeries }
              } = definition;
              return {
                context: {},
                options: {
                  strokeDataPoint: `> strokeDataSeries | lastPoint()`,
                  strokeDataSeries
                }
              };
            }
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Mode"),
          key: "presetSelector",
          editor: "editor.presetSelector",
          editorProps: {
            presets,
            value: ({
              context,
              options
            }) => {
              const initialPreset = (0, configUtils_exports.getInitialPreset)(
                context,
                options,
                presets
              );
              return (initialPreset == null ? void 0 : initialPreset.label) || null;
            }
          }
        }
      ],
      [
        __spreadValues({}, StaticColorEditor)
      ],
      [
        __spreadValues({}, DynamicColorEditor)
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke opacity"),
          option: "strokeOpacity",
          editor: "editor.percent"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke thickness (px)"),
          option: "strokeWidth",
          editor: "editor.number",
          editorProps: {
            min: 1
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke dash style"),
          option: "strokeDasharray",
          editor: "editor.number",
          editorProps: {
            min: 0
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Starting arrow point"),
          option: "fromArrow",
          editor: "editor.toggle",
          editorProps: {
            labelPosition: "right"
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Ending arrow point"),
          option: "toArrow",
          editor: "editor.toggle",
          editorProps: {
            labelPosition: "right"
          }
        }
      ]
    ]
  }
];
var ConnectedLineEditorConfig_default = editorConfig;
//# sourceMappingURL=ConnectedLineEditorConfig.js.map
