/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/visualizations/ConnectedLineOptionsSchema.ts
var ConnectedLineOptionsSchema_exports = {};
__export(ConnectedLineOptionsSchema_exports, {
  default: () => ConnectedLineOptionsSchema_default
});
module.exports = __toCommonJS(ConnectedLineOptionsSchema_exports);

// esm-externals:@splunk/visualizations-shared/schemaUtils
var schemaUtils_exports = {};
__export(schemaUtils_exports, {
  default: () => schemaUtils_default
});
var defaultImport = __toESM(require("@splunk/visualizations-shared/schemaUtils"));
__reExport(schemaUtils_exports, require("@splunk/visualizations-shared/schemaUtils"));
var schemaUtils_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// src/visualizations/ConnectedLineOptionsSchema.ts
var ConnectedLineOptionsSchema_default = {
  toArrow: {
    type: "boolean",
    default: false,
    description: "Specify whether the line begins with an arrow."
  },
  fromArrow: {
    type: "boolean",
    default: false,
    description: "Specify whether the line ends in an arrow."
  },
  strokeColor: {
    anyOf: [
      {
        type: "string",
        pattern: schemaUtils_exports.COLOR_OR_TOKEN_PATTERN,
        description: 'Specify the color of the line. The default for light mode is "#000000". The default for dark mode is "#FFFFFF"'
      },
      {
        type: "string",
        pattern: "^>.*"
      }
    ]
  },
  strokeDataSeries: {
    type: "string",
    pattern: "^>.*",
    description: "Data series for dynamic line coloring.",
    default: '> primary | seriesByType("number")'
  },
  strokeDataPoint: {
    type: "string",
    pattern: "^>.*",
    description: "Data point that will map to the line color.",
    default: "> strokeDataSeries | lastPoint()"
  },
  strokeDasharray: {
    type: "number",
    default: 0,
    description: "Specify the length, in pixels, of both the line segments and the spaces between the line segments when you choose break up a line so that it is not solid."
  },
  strokeWidth: {
    type: "number",
    default: 1,
    description: "Specify the thickness, in pixels, of the line."
  },
  strokeOpacity: {
    type: "number",
    default: 1,
    description: "Specify a number less than one to increase the opacity of the line. For example, if you specify 0.50, the line will have an opacity that is half that of no opacity."
  }
};
//# sourceMappingURL=ConnectedLineOptionsSchema.js.map
