/* Copyright © 2020 Splunk Inc.
SPLUNK CONFIDENTIAL – Use or disclosure of this material in whole or
in part without a valid written license from Splunk Inc. is PROHIBITED. */
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/visualizations/index.ts
var visualizations_exports = {};
__export(visualizations_exports, {
  ConnectedLine: () => ConnectedLine_default,
  ConnectedLineOptionsSchema: () => ConnectedLineOptionsSchema_default
});
module.exports = __toCommonJS(visualizations_exports);

// esm-externals:react
var react_exports = {};
__export(react_exports, {
  default: () => react_default
});
var defaultImport = __toESM(require("react"));
__reExport(react_exports, require("react"));
var react_default = "default" in defaultImport ? defaultImport.default : defaultImport;

// esm-externals:@splunk/ui-utils/i18n
var i18n_exports = {};
__export(i18n_exports, {
  default: () => i18n_default
});
var defaultImport2 = __toESM(require("@splunk/ui-utils/i18n"));
__reExport(i18n_exports, require("@splunk/ui-utils/i18n"));
var i18n_default = "default" in defaultImport2 ? defaultImport2.default : defaultImport2;

// esm-externals:@splunk/react-icons/Line
var Line_exports = {};
__export(Line_exports, {
  default: () => Line_default
});
var defaultImport3 = __toESM(require("@splunk/react-icons/Line"));
__reExport(Line_exports, require("@splunk/react-icons/Line"));
var Line_default = "default" in defaultImport3 ? defaultImport3.default : defaultImport3;

// esm-externals:@splunk/visualization-encoding/Options
var Options_exports = {};
__export(Options_exports, {
  default: () => Options_default
});
var defaultImport4 = __toESM(require("@splunk/visualization-encoding/Options"));
__reExport(Options_exports, require("@splunk/visualization-encoding/Options"));
var Options_default = "default" in defaultImport4 ? defaultImport4.default : defaultImport4;

// esm-externals:@splunk/dashboard-context
var dashboard_context_exports = {};
__export(dashboard_context_exports, {
  default: () => dashboard_context_default
});
var defaultImport5 = __toESM(require("@splunk/dashboard-context"));
__reExport(dashboard_context_exports, require("@splunk/dashboard-context"));
var dashboard_context_default = "default" in defaultImport5 ? defaultImport5.default : defaultImport5;

// esm-externals:@splunk/dashboard-utils
var dashboard_utils_exports = {};
__export(dashboard_utils_exports, {
  default: () => dashboard_utils_default
});
var defaultImport6 = __toESM(require("@splunk/dashboard-utils"));
__reExport(dashboard_utils_exports, require("@splunk/dashboard-utils"));
var dashboard_utils_default = "default" in defaultImport6 ? defaultImport6.default : defaultImport6;

// esm-externals:@splunk/themes
var themes_exports = {};
__export(themes_exports, {
  default: () => themes_default
});
var defaultImport7 = __toESM(require("@splunk/themes"));
__reExport(themes_exports, require("@splunk/themes"));
var themes_default = "default" in defaultImport7 ? defaultImport7.default : defaultImport7;

// esm-externals:@splunk/visualizations-shared/schemaUtils
var schemaUtils_exports = {};
__export(schemaUtils_exports, {
  default: () => schemaUtils_default
});
var defaultImport8 = __toESM(require("@splunk/visualizations-shared/schemaUtils"));
__reExport(schemaUtils_exports, require("@splunk/visualizations-shared/schemaUtils"));
var schemaUtils_default = "default" in defaultImport8 ? defaultImport8.default : defaultImport8;

// src/visualizations/ConnectedLineOptionsSchema.ts
var ConnectedLineOptionsSchema_default = {
  toArrow: {
    type: "boolean",
    default: false,
    description: "Specify whether the line begins with an arrow."
  },
  fromArrow: {
    type: "boolean",
    default: false,
    description: "Specify whether the line ends in an arrow."
  },
  strokeColor: {
    anyOf: [
      {
        type: "string",
        pattern: schemaUtils_exports.COLOR_OR_TOKEN_PATTERN,
        description: 'Specify the color of the line. The default for light mode is "#000000". The default for dark mode is "#FFFFFF"'
      },
      {
        type: "string",
        pattern: "^>.*"
      }
    ]
  },
  strokeDataSeries: {
    type: "string",
    pattern: "^>.*",
    description: "Data series for dynamic line coloring.",
    default: '> primary | seriesByType("number")'
  },
  strokeDataPoint: {
    type: "string",
    pattern: "^>.*",
    description: "Data point that will map to the line color.",
    default: "> strokeDataSeries | lastPoint()"
  },
  strokeDasharray: {
    type: "number",
    default: 0,
    description: "Specify the length, in pixels, of both the line segments and the spaces between the line segments when you choose break up a line so that it is not solid."
  },
  strokeWidth: {
    type: "number",
    default: 1,
    description: "Specify the thickness, in pixels, of the line."
  },
  strokeOpacity: {
    type: "number",
    default: 1,
    description: "Specify a number less than one to increase the opacity of the line. For example, if you specify 0.50, the line will have an opacity that is half that of no opacity."
  }
};

// esm-externals:@splunk/visualization-color-palettes/editors/PresetPalettes
var PresetPalettes_exports = {};
__export(PresetPalettes_exports, {
  default: () => PresetPalettes_default
});
var defaultImport9 = __toESM(require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
__reExport(PresetPalettes_exports, require("@splunk/visualization-color-palettes/editors/PresetPalettes"));
var PresetPalettes_default = "default" in defaultImport9 ? defaultImport9.default : defaultImport9;

// esm-externals:@splunk/visualizations/common/utils/configUtils
var configUtils_exports = {};
__export(configUtils_exports, {
  default: () => configUtils_default
});
var defaultImport10 = __toESM(require("@splunk/visualizations/common/utils/configUtils"));
__reExport(configUtils_exports, require("@splunk/visualizations/common/utils/configUtils"));
var configUtils_default = "default" in defaultImport10 ? defaultImport10.default : defaultImport10;

// src/visualizations/ConnectedLineEditorConfig.ts
var defaultContext = {
  defaultRangeValue: [
    { to: 20, value: "#D41F1F" },
    { from: 20, to: 40, value: "#D94E17" },
    { from: 40, to: 60, value: "#CBA700" },
    { from: 60, to: 80, value: "#669922" },
    { from: 80, value: "#118832" }
  ]
};
var basePresetContext = {
  strokeColorEditorConfig: void 0
};
var basePresetOptions = {
  strokeColor: void 0
};
var presets = [
  {
    label: (0, i18n_exports._)("Static"),
    name: "lineColor.static",
    value: {
      context: __spreadValues({}, basePresetContext),
      options: __spreadValues({}, basePresetOptions)
    }
  },
  {
    label: (0, i18n_exports._)("Dynamic"),
    name: "lineColor.dynamic",
    value: {
      context: __spreadProps(__spreadValues({}, basePresetContext), {
        strokeColorEditorConfig: defaultContext.defaultRangeValue
      }),
      options: __spreadProps(__spreadValues({}, basePresetOptions), {
        strokeColor: "> strokeDataPoint | rangeValue(strokeColorEditorConfig)"
      })
    }
  }
];
var StaticColorEditor = {
  label: (0, i18n_exports._)("Color value"),
  option: "strokeColor",
  editor: "editor.color",
  showEditor: ({ options }) => !(0, configUtils_exports.isDynamicOption)(options == null ? void 0 : options.strokeColor),
  editorProps: {
    labelPosition: "top",
    themeVariable: "@splunk/dashboard-layouts/ConnectedLine.strokeColor"
  }
};
var DynamicColorEditor = {
  label: (0, i18n_exports._)("Color range"),
  option: "strokeColor",
  context: "defaultContext",
  editor: "editor.dynamicColor",
  showEditor: ({ options }) => (0, configUtils_exports.isDynamicOption)(options == null ? void 0 : options.strokeColor),
  editorProps: {
    labelPosition: "top",
    flyoutTitle: (0, i18n_exports._)("Dynamic line color"),
    formatters: [
      {
        label: (0, i18n_exports._)("Ranges"),
        value: "rangeValue",
        isDefault: true,
        // show it by default when open dynamic color flyout
        defaults: {
          strokeDataPoint: defaultContext.defaultRangeValue
        }
      }
    ],
    dataSelectors: [
      {
        label: (0, i18n_exports._)("Color field"),
        value: "strokeDataPoint"
      }
    ],
    defaultPalettesConfig: PresetPalettes_exports.defaultPalettesConfig
  }
};
var editorConfig = [
  {
    label: (0, i18n_exports._)("Selected data field"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Data field"),
          editor: "editor.columnSelector",
          option: "strokeDataSeries",
          context: "strokeDataContext",
          editorProps: {
            dataSourceKey: "primary",
            prepareValue: (definition) => {
              const {
                options: { strokeDataSeries }
              } = definition;
              return {
                context: {},
                options: {
                  strokeDataPoint: `> strokeDataSeries | lastPoint()`,
                  strokeDataSeries
                }
              };
            }
          }
        }
      ]
    ]
  },
  {
    label: (0, i18n_exports._)("Color and style"),
    layout: [
      [
        {
          label: (0, i18n_exports._)("Mode"),
          key: "presetSelector",
          editor: "editor.presetSelector",
          editorProps: {
            presets,
            value: ({
              context,
              options
            }) => {
              const initialPreset = (0, configUtils_exports.getInitialPreset)(
                context,
                options,
                presets
              );
              return (initialPreset == null ? void 0 : initialPreset.label) || null;
            }
          }
        }
      ],
      [
        __spreadValues({}, StaticColorEditor)
      ],
      [
        __spreadValues({}, DynamicColorEditor)
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke opacity"),
          option: "strokeOpacity",
          editor: "editor.percent"
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke thickness (px)"),
          option: "strokeWidth",
          editor: "editor.number",
          editorProps: {
            min: 1
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Stroke dash style"),
          option: "strokeDasharray",
          editor: "editor.number",
          editorProps: {
            min: 0
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Starting arrow point"),
          option: "fromArrow",
          editor: "editor.toggle",
          editorProps: {
            labelPosition: "right"
          }
        }
      ],
      [
        {
          label: (0, i18n_exports._)("Ending arrow point"),
          option: "toArrow",
          editor: "editor.toggle",
          editorProps: {
            labelPosition: "right"
          }
        }
      ]
    ]
  }
];
var ConnectedLineEditorConfig_default = editorConfig;

// src/visualizations/utils/lineUtils.ts
var computeArrowTriangle = (w, h, l, L) => {
  if (l === 0) {
    return { arrowW: 0, arrowH: 0, arrowL: 0 };
  }
  const arrowW = w * L / l;
  const arrowH = h * L / l;
  return { arrowW, arrowH, arrowL: L };
};
var computeFromArrowAngle = (from, to) => {
  if (to.x - from.x === 0) {
    return from.y > to.y ? 90 : 270;
  }
  const angle = Math.atan((to.y - from.y) / (to.x - from.x)) * (180 / Math.PI);
  return from.x > to.x ? angle : 180 + angle;
};
var computeToArrowAngle = (from, to) => {
  if (to.x - from.x === 0) {
    return from.y > to.y ? 270 : 90;
  }
  const angle = Math.atan((to.y - from.y) / (to.x - from.x)) * (180 / Math.PI);
  return from.x > to.x ? 180 + angle : angle;
};
var getNewFrom = (from, to, arrowW, arrowH, fromArrow) => {
  let newFromX;
  let newFromY;
  if (fromArrow) {
    newFromX = from.x > to.x ? from.x - arrowW : from.x + arrowW;
    newFromY = from.y > to.y ? from.y - arrowH : from.y + arrowH;
  } else {
    newFromX = from.x;
    newFromY = from.y;
  }
  return { newFrom: { x: newFromX, y: newFromY } };
};
var getNewTo = (from, to, arrowW, arrowH, toArrow) => {
  let newToX;
  let newToY;
  if (toArrow) {
    newToX = from.x > to.x ? to.x + arrowW : to.x - arrowW;
    newToY = from.y > to.y ? to.y + arrowH : to.y - arrowH;
  } else {
    newToX = to.x;
    newToY = to.y;
  }
  return { newTo: { x: newToX, y: newToY } };
};
var computePathTriangle = (from, to) => {
  const w = Math.abs(from.x - to.x);
  const h = Math.abs(from.y - to.y);
  const l = Math.sqrt(w * w + h * h);
  return { w, h, l };
};

// src/visualizations/ConnectedLine.tsx
var rootSvgStyle = {
  pointerEvents: "none",
  overflow: "visible"
};
var lineStyle = {
  pointerEvents: "auto"
};
var dataContract = {
  requiredDataSources: ["primary"],
  initialRequestParams: {}
};
var vizConfig = {
  optionsSchema: ConnectedLineOptionsSchema_default,
  editorConfig: ConnectedLineEditorConfig_default,
  dataContract,
  key: "abslayout.line",
  name: (0, i18n_exports._)("Connected Line"),
  category: dashboard_context_exports.vizCategories.get("shapes"),
  icon: Line_default,
  events: {},
  // no onEventTrigger called by connected line
  supports: ["dynamic-options"],
  // what capabilities are supported?
  requiredProps: []
};
var defaultOptions = {
  strokeOpacity: 1,
  strokeWidth: 1,
  strokeDasharray: 0,
  strokeDataSeries: '> primary | seriesByType("number")',
  strokeDataPoint: "> strokeDataSeries | lastPoint()",
  fromArrow: false,
  toArrow: false
};
var defaultFrom = {
  x: 0,
  y: 0
};
var defaultTo = {
  x: 150,
  y: 0
};
var empty = {};
var ConnectedLine = ({
  from = defaultFrom,
  to = defaultTo,
  onLineSelect = dashboard_utils_exports.noop,
  options = defaultOptions,
  dataSources = empty,
  context = empty
}) => {
  const { colorScheme } = (0, themes_exports.useSplunkTheme)();
  const renderOptions = (0, react_exports.useMemo)(() => {
    try {
      return Options_exports.Options.evaluate(
        {
          context,
          options: __spreadValues(__spreadValues({}, defaultOptions), options)
        },
        dataSources
      );
    } catch (e) {
      if (e instanceof Error) {
        dashboard_utils_exports.console.error(
          `Unexpected error evaluating line options: ${e.message}`
        );
      }
    }
    return defaultOptions;
  }, [context, options, dataSources]);
  const themeStrokeColor = colorScheme === "light" ? "#000000" : "#ffffff";
  const { w, h, l } = computePathTriangle(from, to);
  const arrowL = 5 * renderOptions.strokeWidth;
  const { arrowW, arrowH } = computeArrowTriangle(w, h, l, arrowL);
  const squashedArrows = arrowL > l && renderOptions.fromArrow && renderOptions.toArrow;
  const fromArrowAngle = computeFromArrowAngle(from, to);
  const toArrowAngle = computeToArrowAngle(from, to);
  const fromArrowId = (0, dashboard_utils_exports.uniqueId)();
  const toArrowId = (0, dashboard_utils_exports.uniqueId)();
  const newW = w + arrowL;
  const newH = h + 2 * arrowL + 10;
  const { newFrom } = getNewFrom(
    from,
    to,
    arrowW,
    arrowH,
    renderOptions.fromArrow
  );
  const { newTo } = getNewTo(from, to, arrowW, arrowH, renderOptions.toArrow);
  return /* @__PURE__ */ react_default.createElement("svg", { width: newW, height: newH, style: rootSvgStyle }, /* @__PURE__ */ react_default.createElement(
    "path",
    {
      "data-test": "arrows",
      d: squashedArrows ? `M${newTo.x} ${newTo.y} L${newFrom.x} ${newFrom.y}` : `M${newFrom.x} ${newFrom.y} L${newTo.x} ${newTo.y}`,
      stroke: renderOptions.strokeColor || themeStrokeColor,
      strokeOpacity: `${renderOptions.strokeOpacity}`,
      strokeWidth: `${renderOptions.strokeWidth}`,
      strokeDasharray: `${renderOptions.strokeDasharray}`,
      fill: "none",
      markerStart: renderOptions.fromArrow ? `url(#${fromArrowId})` : "",
      markerEnd: renderOptions.toArrow ? `url(#${toArrowId})` : ""
    }
  ), /* @__PURE__ */ react_default.createElement(
    "path",
    {
      "data-test": "line",
      onMouseDown: onLineSelect,
      d: `M${from.x} ${from.y} L${to.x} ${to.y}`,
      strokeWidth: `${renderOptions.strokeWidth + 20}`,
      fill: "none",
      stroke: "white",
      strokeOpacity: 0,
      style: lineStyle
    }
  ), /* @__PURE__ */ react_default.createElement("defs", null, /* @__PURE__ */ react_default.createElement(
    "marker",
    {
      id: `${fromArrowId}`,
      markerWidth: "10",
      markerHeight: "10",
      refX: squashedArrows ? "5" : "0",
      refY: "2",
      orient: `${fromArrowAngle}deg`,
      markerUnits: "strokeWidth"
    },
    /* @__PURE__ */ react_default.createElement(
      "path",
      {
        d: "M0,0 L0,4 L5,2 z",
        fill: renderOptions.strokeColor || themeStrokeColor,
        fillOpacity: `${renderOptions.strokeOpacity}`
      }
    )
  ), /* @__PURE__ */ react_default.createElement(
    "marker",
    {
      id: `${toArrowId}`,
      markerWidth: "10",
      markerHeight: "10",
      refX: squashedArrows ? "5" : "0",
      refY: "2",
      orient: `${toArrowAngle}deg`,
      markerUnits: "strokeWidth"
    },
    /* @__PURE__ */ react_default.createElement(
      "path",
      {
        d: "M0,0 L0,4 L5,2 z",
        fill: renderOptions.strokeColor || themeStrokeColor,
        fillOpacity: `${renderOptions.strokeOpacity}`
      }
    )
  )));
};
ConnectedLine.config = vizConfig;
var ConnectedLine_default = ConnectedLine;
//# sourceMappingURL=index.js.map
